/*

*********************************************************************
          
                            MACD Color
                   Copyright  2006  Akuma99
                  http://www.beginnertrader.com/  

       For help on this indicator, tutorials and information 
               visit http://www.beginnertrader.com/
                  
*********************************************************************

*/

#property  copyright "Copyright  2006, Akuma99."
#property  link      "http://www.beginnertrader.com/"

#property  indicator_separate_window
#property  indicator_buffers 6
#property  indicator_color1  C'175,138,122;'         // Maroon
#property  indicator_color2  MediumSeaGreen        // Green
#property  indicator_color3  Maroon
#property  indicator_color4  DarkGreen       // LimeGreen
#property  indicator_color5  Yellow
#property  indicator_color6  Magenta       // Black


extern int    FastHMA_Period     =     12;    // Period of HMA
extern int    SlowHMA_Period     =     26;    // Period of HMA
extern int    SignalLWMA         =     9;
extern int    Price              =     5;     // Apply to Price(0-Close;1-Open;2-High;3-Low;4-Median price;5-Typical price;6-Weighted Close) 
extern double PctFilter          =     0;     // Dynamic filter decimal


double     ind_buffer1[];
double     ind_buffer2[];
double     ind_buffer1b[];
double     ind_buffer2b[];
double     ind_buffer3[];
double     ind_buffer4[];

double     b[999999];

int init() {

   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,4,indicator_color1);
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID,4,indicator_color2);
   SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID,4,indicator_color3);
   SetIndexStyle(3,DRAW_HISTOGRAM,STYLE_SOLID,4,indicator_color4);
   SetIndexStyle(4,DRAW_LINE,EMPTY,2,indicator_color5);
   SetIndexStyle(5,DRAW_LINE,EMPTY,2,indicator_color6);
   SetIndexBuffer(0,ind_buffer1);
   SetIndexBuffer(1,ind_buffer2);
   SetIndexBuffer(2,ind_buffer1b);
   SetIndexBuffer(3,ind_buffer2b);
   SetIndexBuffer(4,ind_buffer3);
   SetIndexBuffer(5,ind_buffer4);
   
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+1);
   
   return(0);

}

int start(){
   
   int limit;
   int counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);

   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;

   for(int i=limit; i>=0; i--) {
      
      b[i] = iCustom(NULL,0,"HMA_v2",Price,FastHMA_Period,PctFilter,1,0,0,0,0,i) - iCustom(NULL,0,"HMA_v2",Price,SlowHMA_Period,PctFilter,1,0,0,0,0,i);
      ind_buffer1[i]=iCustom(NULL,0,"HMA_v2",Price,FastHMA_Period,PctFilter,1,0,0,0,0,i) - iCustom(NULL,0,"HMA_v2",Price,SlowHMA_Period,PctFilter,1,0,0,0,0,i);
      
      clearBuffers(i);
      
      if (b[i] < 0 ) {
         if (b[i] > b[i+1]) {
            ind_buffer1[i] = b[i];
            ind_buffer1b[i] = 0;
         } else if (b[i] < b[i+1]) {
            ind_buffer1b[i] = b[i];
            ind_buffer1[i] = 0;
         }
      } else if (b[i] > 0) {
          if (b[i] < b[i+1]) {
            ind_buffer2[i] = b[i];
            ind_buffer2b[i] = 0;
         } else if (b[i] > b[i+1]) {
            ind_buffer2b[i] = b[i];
            ind_buffer2[i] = 0;
         }
      }
      
      ind_buffer3[i]=iCustom(NULL,0,"HMA_v2",Price,FastHMA_Period,PctFilter,1,0,0,0,0,i) - iCustom(NULL,0,"HMA_v2",Price,SlowHMA_Period,PctFilter,1,0,0,0,0,i);
      
   }
   
   for(i=0; i<limit; i++) {
         ind_buffer4[i]=iMAOnArray(ind_buffer3,Bars,SignalLWMA,0,MODE_LWMA,i);
      }

   return(0);
   
}

void clearBuffers (int i) {
         
      ind_buffer1[i] = NULL;
      ind_buffer1b[i] = NULL;
      ind_buffer2[i] = NULL;
      ind_buffer2b[i] = NULL;
         
}